/*

                      Inertia Realtime 3D Rendering Engine
            Copyright (c) 1997, Alex Chalfin. All Rights Reserved.
           DISTRIBUTION OF THIS SOURCE CODE IS STRICTLY PROHIBITED

*/

#include "cull.h"
#include "shade.h"
#include "clip.h"
#include "xform.h"

void CullPolys(VectorObject *Obj, Vertex3d *CullVector)
{
  int    i;
  Triangle *P;
  float   cvx;

  for (i = 0, P = Obj->Polygons; i < Obj->NumPoly; i++, P++)
  {
    cvx =  (CullVector->x - P->B->Loc.x) * P->N.x +
           (CullVector->y - P->B->Loc.y) * P->N.y +
           (CullVector->z - P->B->Loc.z) * P->N.z;

    if (cvx >= 0.0)
    {
      P->Visible    = 1;
      P->A->Visible = 1;
      P->B->Visible = 1;
      P->C->Visible = 1;
    }
    else
    {
      P->Visible = 0;
    }
  }
}


void ShadeXForm(ViewObject *View, VectorObject *Obj, float *M)
{
  int   i;

  Shaders[Obj->RenderMask & SHADE_MASK](View, Obj, M);

  if ((Obj->RenderMask & SURFACE_MASK) == REFLECTION)
    ReflectionMap(View, Obj, M);

  XForm(View, Obj, M);

  ClipPolygons(View, Obj);

  Project(View, Obj);

  for (i = 0; i < Obj->NumPoly; i++)
  {
    if (Obj->Polygons[i].Visible == 1)
      AddPolygonToRenderList(&Obj->Polygons[i], Obj->RenderMask, 1);
  }
}
