void G_UnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  if (PreviousState != (UNSHADED | REFLECTION))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (UNSHADED | REFLECTION);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  STD_TRI_SETUP;
  STD_ENV_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_AmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  int a;
  float GlossVal;

  if (PreviousState != (AMBIENT | REFLECTION))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (AMBIENT | REFLECTION);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL_ALPHA,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->Shade * 1023)]);

  a = (int)(pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->Shade) + GlossVal);

  grConstantColorValue((a << 24));

  STD_TRI_SETUP;
  STD_ENV_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_LambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  int a;
  float GlossVal;

  if (PreviousState != (LAMBERT | REFLECTION))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (LAMBERT | REFLECTION);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL_ALPHA,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->Shade * 1023)]);

  a = (int)(pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->Shade) + GlossVal);

  grConstantColorValue((a << 24));

  STD_TRI_SETUP;
  STD_ENV_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_GouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{
  float GlossVal;

  if (PreviousState != (GOURAUD | REFLECTION))
    {
      PreviousState = (GOURAUD | REFLECTION);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL_ALPHA,
                     GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                     GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_NONE, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->A->Shade * 1023)]);
  A.a = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->A->Shade) + GlossVal);
  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->B->Shade * 1023)]);
  B.a = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->B->Shade) + GlossVal);
  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->C->Shade * 1023)]);
  C.a = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->C->Shade) + GlossVal);

  STD_TRI_SETUP;
  STD_ENV_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_PhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y)
{}
