;*===========================================================================*
;                    Inertia Realtime 3D Rendering Engine
;    Copyright (c) 1996, Alex Chalfin, Jeroen Bouwens. All Rights Reserved.
;          DISTRIBUTION OF THIS SOURCE CODE IS STRICTLY PROHIBITED
;*===========================================================================*

;===================
; STRUCDEF.ASM
; code: Alex Chalfin
;===================
                                ;
                                ;
VectorObject struc              ; VectorObject structure
    NumVert   dd ?              ;
    NumPoly   dd ?              ;
    Vertexs   dd ?              ;
    Polygons  dd ?              ;
VectorObject ends               ;
                                ;
ViewObject struc                ; ViewObject structure
    CenterX    dd ?             ;
    CenterY    dd ?             ;
    WinMinX    dd ?             ;
    WinMinY    dd ?             ;
    WinMaxX    dd ?             ;
    WinMaxY    dd ?             ;
                                ;
    InvCamZFac dd ?             ;
    InvCamYFac dd ?             ;
ViewObject ends                 ;
                                ;
Vertex struc                    ; Vertex structure
    Locx      dd ?              ; 0
    Locy      dd ?              ; 4
    Locz      dd ?              ; 8
    Camx      dd ?              ; 12
    Camy      dd ?              ; 16
    Camz      dd ?              ; 20
    ScrX      dd ?              ; 24
    ScrY      dd ?              ; 28
    EnvX      dd ?              ; 32
    EnvY      dd ?              ; 36
    VNormalX  dd ?              ; 40
    VNormalY  dd ?              ; 44
    VNormalZ  dd ?              ; 48
    OneOverZ  dd ?              ; 52
    VShade    dd ?              ; 56
    VVisible  dd ?              ; 60
Vertex ends                     ;
                                ;
Polygon struc                   ; Polygon structure
    PolyAPtr  dd ?              ;
    PolyBPtr  dd ?              ;
    PolyCPtr  dd ?              ;
    NormalX   dd ?              ;
    NormalY   dd ?              ;
    NormalZ   dd ?              ;
    UV1x      dd ?              ;
    UV1y      dd ?              ;
    UV2x      dd ?              ;
    UV2y      dd ?              ;
    UV3x      dd ?              ;
    UV3y      dd ?              ;
    Texture   dd ?              ;
    IBuffer   dd ?              ;
    PShade    dd ?              ;
    PVisible  dd ?              ;
    pColor    dd ?              ;
Polygon ends                    ;
                                ;
Vector struc                    ; Vector structure
    X3D      dd ?               ;
    Y3D      dd ?               ;
    Z3D      dd ?               ;
Vector ends                     ;
                                ;
Vector2d struc                  ; Vector structure
    X2D      dd ?               ;
    Y2D      dd ?               ;
Vector2d ends                   ;
                                ;
TextureS struc                  ; Texture structure
    TexData  dd ?               ;
TextureS ends                   ;
                                ;
RenderListS struc               ;
    Allocated dd ?              ;
    SortList  dd ?              ;
    RLCount   dd ?              ;
    MSBList   dd 256 dup(0)     ;
    LSBList   dd 256 dup(0)     ;
RenderListS ends                ;
                                ;
SortRec struc                   ;
    ZMid         dd ?           ;
    ShadeSurface dd ?           ;
    pNext        dd ?           ;
    Poly         dd ?           ;
SortRec ends                    ;
                                ;
LightStructure struc            ;
    NumLights    dd ?           ;
    TempLights   dd 60 dup(0) ; Array[0..7] of Vertex3d
    tLights      dd 60 dup(0) ; Array[0..7] of Vertex3d
LightStructure ends             ;
                                ;
VERTEX_SIZE    EQU  64          ; vertex struc size
POLYGON_SIZE   EQU  68          ; polygon struc size
SORTREC_SIZE   EQU  16          ; sortrec struc size

